Index: .bzrignore
===================================================================
--- .bzrignore	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ .bzrignore	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -135,5 +135,5 @@
 uspace/dist/drv/root/
 uspace/dist/drv/rootpc/
-uspace/dist/drv/rootvirt/
+uspace/dist/drv/virt/
 uspace/dist/drv/rtl8139/
 uspace/dist/drv/rtl8169/
@@ -202,7 +202,7 @@
 uspace/drv/char/xtkbd/xtkbd
 uspace/drv/fb/kfb/kfb
-uspace/drv/infrastructure/root/root
-uspace/drv/infrastructure/rootpc/rootpc
-uspace/drv/infrastructure/rootvirt/rootvirt
+uspace/drv/root/root/root
+uspace/drv/root/virt/virt
+uspace/drv/platform/rootpc/rootpc
 uspace/drv/nic/e1k/e1k
 uspace/drv/nic/ne2k/ne2k
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ boot/Makefile.common	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -127,6 +127,6 @@
 
 RD_DRVS_ESSENTIAL = \
-	infrastructure/root \
-	infrastructure/rootvirt \
+	root/root \
+	root/virt \
 	fb/kfb 
 
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ boot/arch/amd64/Makefile.inc	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -35,5 +35,5 @@
 
 RD_DRVS_ESSENTIAL += \
-	infrastructure/rootpc \
+	platform/pc \
 	block/ata_bd \
 	bus/pci/pciintel \
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ boot/arch/arm32/Makefile.inc	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -60,12 +60,23 @@
 
 ifeq ($(MACHINE), gta02)
-RD_SRVS_ESSENTIAL += \
-	$(USPACE_PATH)/srv/hid/s3c24xx_ts/s3c24xx_ts \
-	$(USPACE_PATH)/srv/hw/char/s3c24xx_uart/s3c24ser
+	RD_SRVS_ESSENTIAL += \
+		$(USPACE_PATH)/srv/hid/s3c24xx_ts/s3c24xx_ts \
+		$(USPACE_PATH)/srv/hw/char/s3c24xx_uart/s3c24ser
+endif
+
+ifeq ($(MACHINE), $(filter $(MACHINE),beagleboardxm beaglebone))
+	RD_DRVS_ESSENTIAL += \
+		platform/amdm37x \
+		fb/amdm37x_dispc
+endif
+
+ifeq ($(MACHINE), integratorcp)
+	RD_DRVS_ESSENTIAL += \
+		char/pl050 \
+		char/xtkbd \
+		platform/icp
 endif
 
 RD_DRVS_ESSENTIAL += \
-	infrastructure/rootamdm37x \
-	fb/amdm37x_dispc \
 	bus/usb/ehci \
 	bus/usb/ohci \
Index: boot/arch/ia64/Makefile.inc
===================================================================
--- boot/arch/ia64/Makefile.inc	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ boot/arch/ia64/Makefile.inc	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -66,5 +66,5 @@
 
 RD_DRVS_ESSENTIAL += \
-	infrastructure/rootpc \
+	platform/pc \
 	bus/pci/pciintel \
 	bus/isa \
Index: boot/arch/mips32/Makefile.inc
===================================================================
--- boot/arch/mips32/Makefile.inc	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ boot/arch/mips32/Makefile.inc	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -52,5 +52,5 @@
 ifeq ($(MACHINE), $(filter $(MACHINE),bmalta lmalta))
 	RD_DRVS_ESSENTIAL += \
-		infrastructure/rootmalta \
+		platform/malta \
 		block/ata_bd \
 		bus/pci/pciintel \
Index: boot/arch/ppc32/Makefile.inc
===================================================================
--- boot/arch/ppc32/Makefile.inc	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ boot/arch/ppc32/Makefile.inc	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -43,5 +43,5 @@
 
 RD_DRVS_ESSENTIAL += \
-	infrastructure/rootmac \
+	platform/mac \
 	bus/pci/pciintel \
 	bus/usb/ohci \
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/Makefile	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -66,12 +66,12 @@
 SIZEOK_MAP = generic/src/debug/sizeok_map.o
 
-.PHONY: all clean
+.PHONY: all clean autogen_clean
 
 all: $(VERSION_DEF) $(COMMON_MAKEFILE) $(COMMON_HEADER) $(CONFIG_MAKEFILE) $(CONFIG_HEADER) $(BIN) $(DISASM)
 	-[ -f $(DEPEND) ] && cp -a $(DEPEND) $(DEPEND_PREV)
 
-clean:
+clean: autogen_clean
 	rm -f $(DEPEND) $(DEPEND_PREV) $(RAW) $(BIN) $(MAP) $(JOB) $(MAP_PREV) $(DISASM) $(DUMP) $(REAL_MAP).* arch/*/_link.ld arch/*/include/arch/common.h
-	find generic/src/ arch/*/src/ genarch/src/ test/ -name '*.o' -follow -exec rm \{\} \;
+	find generic/src/ arch/*/src/ genarch/src/ test/ -name '*.o' -follow -exec rm '{}' \;
 
 ## Common compiler flags
@@ -367,4 +367,8 @@
 GENARCH_OBJECTS := $(addsuffix .o,$(basename $(GENARCH_SOURCES)))
 
+ARCH_AUTOGENS_H := $(addsuffix .h,$(basename $(ARCH_AUTOGENS_AG)))
+ARCH_AUTOGENS_PROBE_C := $(addsuffix .ag.probe.c,$(basename $(ARCH_AUTOGENS_AG)))
+ARCH_AUTOGENS_PROBE_S := $(addsuffix .ag.probe.s,$(basename $(ARCH_AUTOGENS_AG)))
+
 LFLAGS_LTO := $(addprefix -Xlinker ,$(LFLAGS))
 
@@ -397,4 +401,9 @@
 $(LINK): $(LINK).in $(DEPEND)
 	$(CC) $(DEFS) $(CFLAGS) -D__ASM__ -D__LINKER__ -E -x c $< | grep -v "^\#" > $@
+
+%.h: %.ag
+	$(AUTOGEN) probe $< >$<.probe.c
+	$(GCC) $(DEFS) $(GCC_CFLAGS) -S -o $<.probe.s $<.probe.c
+	$(AUTOGEN) generate $< <$<.probe.s >$@   
 
 %.o: %.S $(DEPEND)
@@ -441,5 +450,5 @@
 	$(GENMAP) $(MAP_PREV) $(DUMP) $@
 
-$(DEPEND): $(COMMON_HEADER_ARCH)
+$(DEPEND): $(COMMON_HEADER_ARCH) $(ARCH_AUTOGENS_H)
 	makedepend -f - -- $(DEPEND_DEFS) $(CFLAGS) -- $(ARCH_SOURCES) $(GENARCH_SOURCES) $(GENERIC_SOURCES) > $@ 2> /dev/null
 	-[ -f $(DEPEND_PREV) ] && diff -q $(DEPEND_PREV) $@ && mv -f $(DEPEND_PREV) $@
@@ -447,2 +456,5 @@
 $(COMMON_HEADER_ARCH): $(COMMON_HEADER)
 	ln -sfn ../../../../$< $@
+
+autogen_clean:
+	-rm $(ARCH_AUTOGENS_H) $(ARCH_AUTOGENS_PROBE_C) $(ARCH_AUTOGENS_PROBE_S)
Index: kernel/arch/abs32le/Makefile.inc
===================================================================
--- kernel/arch/abs32le/Makefile.inc	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/arch/abs32le/Makefile.inc	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -50,5 +50,4 @@
 	arch/$(KARCH)/src/userspace.c \
 	arch/$(KARCH)/src/cpu/cpu.c \
-	arch/$(KARCH)/src/ddi/ddi.c \
 	arch/$(KARCH)/src/smp/smp.c \
 	arch/$(KARCH)/src/smp/ipi.c \
Index: kernel/arch/amd64/Makefile.inc
===================================================================
--- kernel/arch/amd64/Makefile.inc	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/arch/amd64/Makefile.inc	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -86,2 +86,6 @@
 		arch/$(KARCH)/src/smp/smp.c
 endif
+
+ARCH_AUTOGENS_AG = \
+	arch/$(KARCH)/include/arch/istate_struct.ag
+
Index: kernel/arch/amd64/include/arch/istate.h
===================================================================
--- kernel/arch/amd64/include/arch/istate.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/arch/amd64/include/arch/istate.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -38,31 +38,9 @@
 #include <trace.h>
 
-/** This is passed to interrupt handlers */
-typedef struct istate {
-	uint64_t rax;
-	uint64_t rbx;
-	uint64_t rcx;
-	uint64_t rdx;
-	uint64_t rsi;
-	uint64_t rdi;
-	uint64_t rbp;
-	uint64_t r8;
-	uint64_t r9;
-	uint64_t r10;
-	uint64_t r11;
-	uint64_t r12;
-	uint64_t r13;
-	uint64_t r14;
-	uint64_t r15;
-	uint64_t alignment;   /* align rbp_frame on multiple of 16 */
-	uint64_t rbp_frame;   /* imitation of frame pointer linkage */
-	uint64_t rip_frame;   /* imitation of return address linkage */
-	uint64_t error_word;  /* real or fake error word */
-	uint64_t rip;
-	uint64_t cs;
-	uint64_t rflags;
-	uint64_t rsp;         /* only if istate_t is from uspace */
-	uint64_t ss;          /* only if istate_t is from uspace */
-} istate_t;
+#ifdef KERNEL
+#include <arch/istate_struct.h>
+#else
+#include <libarch/istate_struct.h>
+#endif
 
 #define RPL_USER	3
Index: kernel/arch/amd64/include/arch/istate_struct.ag
===================================================================
--- kernel/arch/amd64/include/arch/istate_struct.ag	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
+++ kernel/arch/amd64/include/arch/istate_struct.ag	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -0,0 +1,146 @@
+# Copyright (c) 2014 Jakub Jermar 
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+{
+        name : istate,
+
+        includes : [
+                {
+                        guard : KERNEL,
+                        include : <typedefs.h>
+                },
+                {
+                        negative-guard: KERNEL,
+                        include : <sys/types.h>
+                }
+        ],
+
+        members : [
+                {
+                        name : rax,
+                        type : uint64_t
+                },
+                {
+                        name : rbx,
+                        type : uint64_t
+                },
+                {
+                        name : rcx,
+                        type : uint64_t
+                },
+                {
+                        name : rdx,
+                        type : uint64_t
+                },
+                {
+                        name : rsi,
+                        type : uint64_t
+                },
+                {
+                        name : rdi,
+                        type : uint64_t
+                },
+                {
+                        name : rbp,
+                        type : uint64_t
+                },
+                {
+                        name : r8,
+                        type : uint64_t
+                },
+                {
+                        name : r9,
+                        type : uint64_t
+                },
+                {
+                        name : r10,
+                        type : uint64_t
+                },
+                {
+                        name : r11,
+                        type : uint64_t
+                },
+                {
+                        name : r12,
+                        type : uint64_t
+                },
+                {
+                        name : r13,
+                        type : uint64_t
+                },
+                {
+                        name : r14,
+                        type : uint64_t
+                },
+                {
+                        name : r15,
+                        type : uint64_t
+                },
+                {
+                        # align rbp_frame on multiple of 16
+                        name : alignment,
+                        type : uint64_t
+                },
+                {
+                        # imitation of frame pointer linkage
+                        name : rbp_frame,
+                        type : uint64_t
+                },
+                {
+                        # imitation of frame address linkage
+                        name : rip_frame,
+                        type : uint64_t
+                },
+                {
+                        # real or fake error word
+                        name : error_word,
+                        type : uint64_t
+                },
+                {
+                        name : rip,
+                        type : uint64_t
+                },
+                {
+                        name : cs,
+                        type : uint64_t
+                },
+                {
+                        name : rflags,
+                        type : uint64_t
+                },
+                {
+                        # only if istate_t is from uspace
+                        name : rsp,
+                        type : uint64_t
+                },
+                {
+                        # only if istate_t is from uspace
+                        name : ss,
+                        type : uint64_t
+                }
+        ]
+}
Index: kernel/arch/amd64/src/asm.S
===================================================================
--- kernel/arch/amd64/src/asm.S	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/arch/amd64/src/asm.S	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -29,4 +29,5 @@
 #include <arch/pm.h>
 #include <arch/mm/page.h>
+#include <arch/istate_struct.h>
 
 .text
@@ -142,34 +143,9 @@
 	ret
 
-#define ISTATE_OFFSET_RAX		0
-#define ISTATE_OFFSET_RBX		8
-#define ISTATE_OFFSET_RCX		16
-#define ISTATE_OFFSET_RDX		24
-#define ISTATE_OFFSET_RSI		32
-#define ISTATE_OFFSET_RDI		40
-#define ISTATE_OFFSET_RBP		48
-#define ISTATE_OFFSET_R8		56
-#define ISTATE_OFFSET_R9		64
-#define ISTATE_OFFSET_R10		72
-#define ISTATE_OFFSET_R11		80
-#define ISTATE_OFFSET_R12		88	
-#define ISTATE_OFFSET_R13 		96
-#define ISTATE_OFFSET_R14		104
-#define ISTATE_OFFSET_R15		112
-#define ISTATE_OFFSET_ALIGNMENT		120
-#define ISTATE_OFFSET_RBP_FRAME		128
-#define ISTATE_OFFSET_RIP_FRAME		136
-#define ISTATE_OFFSET_ERROR_WORD	144
-#define ISTATE_OFFSET_RIP		152
-#define ISTATE_OFFSET_CS		160
-#define ISTATE_OFFSET_RFLAGS		168
-#define ISTATE_OFFSET_RSP		176
-#define ISTATE_OFFSET_SS		184
-
 /*
  * Size of the istate structure without the hardware-saved part and without the
  * error word.
  */
-#define ISTATE_SOFT_SIZE	144
+#define ISTATE_SOFT_SIZE	ISTATE_SIZE - (6 * 8)
 
 /**
Index: kernel/arch/amd64/src/ddi/ddi.c
===================================================================
--- kernel/arch/amd64/src/ddi/ddi.c	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/arch/amd64/src/ddi/ddi.c	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -45,67 +45,4 @@
 #include <arch.h>
 #include <align.h>
-
-/** Enable I/O space range for task.
- *
- * Interrupts are disabled and task is locked.
- *
- * @param task   Task.
- * @param ioaddr Startign I/O space address.
- * @param size   Size of the enabled I/O range.
- *
- * @return 0 on success or an error code from errno.h.
- *
- */
-int ddi_iospace_enable_arch(task_t *task, uintptr_t ioaddr, size_t size)
-{
-	size_t elements = ioaddr + size;
-	if (elements > IO_PORTS)
-		return ENOENT;
-	
-	if (task->arch.iomap.elements < elements) {
-		/*
-		 * The I/O permission bitmap is too small and needs to be grown.
-		 */
-		
-		void *store = malloc(bitmap_size(elements), FRAME_ATOMIC);
-		if (!store)
-			return ENOMEM;
-		
-		bitmap_t oldiomap;
-		bitmap_initialize(&oldiomap, task->arch.iomap.elements,
-		    task->arch.iomap.bits);
-		
-		bitmap_initialize(&task->arch.iomap, elements, store);
-		
-		/*
-		 * Mark the new range inaccessible.
-		 */
-		bitmap_set_range(&task->arch.iomap, oldiomap.elements,
-		    elements - oldiomap.elements);
-		
-		/*
-		 * In case there really existed smaller iomap,
-		 * copy its contents and deallocate it.
-		 */
-		if (oldiomap.bits) {
-			bitmap_copy(&task->arch.iomap, &oldiomap,
-			    oldiomap.elements);
-			
-			free(oldiomap.bits);
-		}
-	}
-	
-	/*
-	 * Enable the range and we are done.
-	 */
-	bitmap_clear_range(&task->arch.iomap, (size_t) ioaddr, size);
-	
-	/*
-	 * Increment I/O Permission bitmap generation counter.
-	 */
-	task->arch.iomapver++;
-	
-	return 0;
-}
 
 /** Install I/O Permission bitmap.
Index: kernel/arch/arm32/Makefile.inc
===================================================================
--- kernel/arch/arm32/Makefile.inc	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/arch/arm32/Makefile.inc	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -54,5 +54,4 @@
 	arch/$(KARCH)/src/dummy.S \
 	arch/$(KARCH)/src/cpu/cpu.c \
-	arch/$(KARCH)/src/ddi/ddi.c \
 	arch/$(KARCH)/src/interrupt.c \
 	arch/$(KARCH)/src/exception.c \
@@ -96,2 +95,6 @@
 	ARCH_SOURCES += genarch/src/drivers/pl050/pl050.c
 endif
+
+ARCH_AUTOGENS_AG = \
+	arch/$(KARCH)/include/arch/istate_struct.ag
+
Index: kernel/arch/arm32/include/arch/istate.h
===================================================================
--- kernel/arch/arm32/include/arch/istate.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/arch/arm32/include/arch/istate.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -39,35 +39,13 @@
 #ifdef KERNEL
 
+#include <arch/istate_struct.h>
 #include <arch/regutils.h>
 
 #else /* KERNEL */
 
+#include <libarch/istate_struct.h>
 #include <libarch/regutils.h>
 
 #endif /* KERNEL */
-
-/** Struct representing CPU state saved when an exception occurs. */
-typedef struct istate {
-	uint32_t dummy;
-	uint32_t spsr;
-	uint32_t sp;
-	uint32_t lr;
-	
-	uint32_t r0;
-	uint32_t r1;
-	uint32_t r2;
-	uint32_t r3;
-	uint32_t r4;
-	uint32_t r5;
-	uint32_t r6;
-	uint32_t r7;
-	uint32_t r8;
-	uint32_t r9;
-	uint32_t r10;
-	uint32_t fp;
-	uint32_t r12;
-	
-	uint32_t pc;
-} istate_t;
 
 /** Set Program Counter member of given istate structure.
Index: kernel/arch/arm32/include/arch/istate_struct.ag
===================================================================
--- kernel/arch/arm32/include/arch/istate_struct.ag	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
+++ kernel/arch/arm32/include/arch/istate_struct.ag	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -0,0 +1,119 @@
+# Copyright (c) 2014 Jakub Jermar 
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+{
+        name : istate,
+
+        includes : [
+                {
+                        guard : KERNEL,
+                        include : <typedefs.h>
+                },
+                {
+                        negative-guard : KERNEL,
+                        include : <sys/types.h>
+                }
+        ],
+
+        members : [
+                {
+                        name : dummy,
+                        type : uint32_t
+                },
+                {
+                        name : spsr,
+                        type : uint32_t
+                },
+                {
+                        name : sp,
+                        type : uint32_t
+                },
+                {
+                        name : lr,
+                        type : uint32_t
+                },
+
+                {
+                        name : r0,
+                        type : uint32_t
+                },
+                {
+                        name : r1,
+                        type : uint32_t
+                },
+                {
+                        name : r2,
+                        type : uint32_t
+                },
+                {
+                        name : r3,
+                        type : uint32_t
+                },
+                {
+                        name : r4,
+                        type : uint32_t
+                },
+                {
+                        name : r5,
+                        type : uint32_t
+                },
+                {
+                        name : r6,
+                        type : uint32_t
+                },
+                {
+                        name : r7,
+                        type : uint32_t
+                },
+                {
+                        name : r8,
+                        type : uint32_t
+                },
+                {
+                        name : r9,
+                        type : uint32_t
+                },
+                {
+                        name : r10,
+                        type : uint32_t
+                },
+                {
+                        name : fp,
+                        type : uint32_t
+                },
+                {
+                        name : r12,
+                        type : uint32_t
+                },
+
+                {
+                        name : pc,
+                        type : uint32_t
+                }
+        ]
+}
+
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/arch/ia32/Makefile.inc	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -105,2 +105,6 @@
 	arch/$(KARCH)/src/fpu_context.c \
 	arch/$(KARCH)/src/syscall.c
+
+ARCH_AUTOGENS_AG = \
+	arch/$(KARCH)/include/arch/istate_struct.ag
+
Index: kernel/arch/ia32/include/arch/istate.h
===================================================================
--- kernel/arch/ia32/include/arch/istate.h	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/arch/ia32/include/arch/istate.h	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -38,33 +38,9 @@
 #include <trace.h>
 
-typedef struct istate {
-	/*
-	 * The strange order of the GPRs is given by the requirement to use the
-	 * istate structure for both regular interrupts and exceptions as well
-	 * as for syscall handlers which use this order as an optimization.
-	 */
-	uint32_t edx;
-	uint32_t ecx;
-	uint32_t ebx;
-	uint32_t esi;
-	uint32_t edi;
-	uint32_t ebp;
-	uint32_t eax;
-	
-	uint32_t ebp_frame;  /* imitation of frame pointer linkage */
-	uint32_t eip_frame;  /* imitation of return address linkage */
-	
-	uint32_t gs;
-	uint32_t fs;
-	uint32_t es;
-	uint32_t ds;
-	
-	uint32_t error_word;  /* real or fake error word */
-	uint32_t eip;
-	uint32_t cs;
-	uint32_t eflags;
-	uint32_t esp;         /* only if istate_t is from uspace */
-	uint32_t ss;          /* only if istate_t is from uspace */
-} istate_t;
+#ifdef KERNEL
+#include <arch/istate_struct.h>
+#else
+#include <libarch/istate_struct.h>
+#endif /* KERNEL */
 
 #define RPL_USER	3
Index: kernel/arch/ia32/include/arch/istate_struct.ag
===================================================================
--- kernel/arch/ia32/include/arch/istate_struct.ag	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
+++ kernel/arch/ia32/include/arch/istate_struct.ag	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -0,0 +1,135 @@
+# Copyright (c) 2014 Jakub Jermar 
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+{
+        name : istate,
+
+        includes : [
+                {
+                        guard : KERNEL,
+                        include : <typedefs.h>
+                },
+                {
+                        negative-guard: KERNEL,
+                        include : <sys/types.h>
+                }
+        ],
+
+        members : [
+
+                #
+                # The strange order of the GPRs is given by the requirement to use the
+                # istate structure for both regular interrupts and exceptions as well
+                # as for syscall handlers which use this order as an optimization.
+                #
+
+                {
+                        name : edx,
+                        type : uint32_t
+                },
+                {
+                        name : ecx,
+                        type : uint32_t
+                },
+                {
+                        name : ebx,
+                        type : uint32_t
+                },
+                {
+                        name : esi,
+                        type : uint32_t
+                },
+                {
+                        name : edi,
+                        type : uint32_t
+                },
+                {
+                        name : ebp,
+                        type : uint32_t
+                },
+                {
+                        name : eax,
+                        type : uint32_t
+                },
+
+                {
+                        # imitation of frame pointer linkage
+                        name : ebp_frame,
+                        type : uint32_t
+                },
+                {
+                        # imitation of return address linkage
+                        name : eip_frame,
+                        type : uint32_t
+                },
+
+                {
+                        name : gs,
+                        type : uint32_t
+                },
+                {
+                        name : fs,
+                        type : uint32_t
+                },
+                {
+                        name : es,
+                        type : uint32_t
+                },
+                {
+                        name : ds,
+                        type : uint32_t
+                },
+
+                {
+                        # real or fake error word
+                        name : error_word,
+                        type : uint32_t
+                },
+                {
+                        name : eip,
+                        type : uint32_t
+                },
+                {
+                        name : cs,
+                        type : uint32_t
+                },
+                {
+                        name : eflags,
+                        type : uint32_t
+                },
+                {
+                        # only if istate_t is from uspace
+                        name : esp,
+                        type : uint32_t
+                },
+                {
+                        # only if istate_t is from uspace
+                        name : ss,
+                        type : uint32_t
+                }
+        ]
+}
Index: kernel/arch/ia32/src/asm.S
===================================================================
--- kernel/arch/ia32/src/asm.S	(revision 00ddb40e40d76e7f5d1a1b654498668aa2cc0e10)
+++ kernel/arch/ia32/src/asm.S	(revision 5713e5faae70dc250ec698512ff0096c4b9891ce)
@@ -34,4 +34,5 @@
 #include <arch/cpu.h>
 #include <arch/mm/page.h>
+#include <arch/istate_struct.h>
 
 .text
@@ -136,29 +137,9 @@
 	ret
 
-#define ISTATE_OFFSET_EDX         0
-#define ISTATE_OFFSET_ECX         4
-#define ISTATE_OFFSET_EBX         8
-#define ISTATE_OFFSET_ESI         12
-#define ISTATE_OFFSET_EDI         16 
-#define ISTATE_OFFSET_EBP         20
-#define ISTATE_OFFSET_EAX         24
-#define ISTATE_OFFSET_EBP_FRAME   28
-#define ISTATE_OFFSET_EIP_FRAME   32
-#define ISTATE_OFFSET_GS          36
-#define ISTATE_OFFSET_FS          40
-#define ISTATE_OFFSET_ES          44
-#define ISTATE_OFFSET_DS          48
-#define ISTATE_OFFSET_ERROR_WORD  52
-#define ISTATE_OFFSET_EIP         56
-#define ISTATE_OFFSET_CS          60
-#define ISTATE_OFFSET_EFLAGS      64
-#define ISTATE_OFFSET_ESP         68
-#define ISTATE_OFFSET_SS          72
-
 /*
  * Size of the istate structure without the hardware-saved part
  * and without the error word.
  */
-#define ISTATE_SOFT_SIZE  52
+#define ISTATE_SOFT_SIZE	ISTATE_SIZE - (6 * 4) 
 
 /*
